import Summary from '~/components/report_cards/chemical_probe/Summary.vue'
import ControlStructuresAndUse from '~/components/report_cards/chemical_probe/ControlStructuresAndUse.vue'
import ProbesForThisCompound from '~/components/report_cards/chemical_probe/ProbesForThisCompound.vue'
import ProbeProfile from '~/components/report_cards/chemical_probe/ProbeProfile.vue'
import ProbeMechanism from '~/components/report_cards/chemical_probe/ProbeMechanism.vue'
import CompoundCrystalStructures from '~/components/report_cards/chemical_probe/CompoundCrystalStructures.vue'
import CalculatedProperties from '~/components/report_cards/chemical_probe/CalculatedProperties.vue'
import EntityNames from '~/web-components-submodule/standardisation/EntityNames.js'
import CellViabilityAndHealthData from '~/components/report_cards/chemical_probe/CellViabilityAndHealthData.vue'

const methods = {
  generateReportCardStructure(
    itemID,
    prefName,
    isChemicalProbe,
    isNegativeControl
  ) {
    if (isChemicalProbe) {
      return {
        title: prefName,
        entityName: EntityNames.EubopenCompound.singularEntityName,
        sections: [
          {
            id: 'Summary',
            title: 'Summary',
            component: Summary,
            index: 0,
          },
          {
            id: 'ProbeMechanism',
            title: 'Mechanism of Action',
            component: ProbeMechanism,
            index: 1,
          },
          {
            id: 'ControlStructuresAndUse',
            title: 'Negative Controls',
            component: ControlStructuresAndUse,
            index: 2,
          },
          {
            id: 'ProbeProfile',
            title: 'Activity Profile',
            component: ProbeProfile,
            index: 3,
          },
          {
            id: 'CellViabilityAndHealthData',
            title: 'Cell Viability And Health Data',
            component: CellViabilityAndHealthData,
            index: 4,
          },
          {
            id: 'CalculatedProperties',
            title: 'Calculated Properties',
            component: CalculatedProperties,
            componentParams: {
              entityID: EntityNames.EubopenCompound.entityID,
            },

            index: 5,
          },
          {
            id: 'CrystalStructures',
            title: 'PBD Ligand Codes',
            component: CompoundCrystalStructures,
            index: 6,
          },
        ],
      }
    }

    if (isNegativeControl) {
      return {
        title: prefName,
        entityName: EntityNames.EubopenCompound.singularEntityName,
        sections: [
          {
            id: 'Summary',
            title: 'Summary',
            component: Summary,
            index: 0,
          },
          {
            id: 'ProbeMechanism',
            title: 'Mechanism of Action',
            component: ProbeMechanism,
            index: 1,
          },
          {
            id: 'ProbesForThisCompound',
            title: 'Related Probes',
            component: ProbesForThisCompound,
            index: 2,
          },
          {
            id: 'ProbeProfile',
            title: 'Activity Profile',
            component: ProbeProfile,
            index: 3,
          },
          {
            id: 'CalculatedProperties',
            title: 'Calculated Properties',
            component: CalculatedProperties,
            componentParams: {
              entityID: EntityNames.EubopenCompound.entityID,
            },

            index: 4,
          },
          {
            id: 'CrystalStructures',
            title: 'PBD Ligand Codes',
            component: CompoundCrystalStructures,
            index: 5,
          },
        ],
      }
    }

    return {
      title: prefName,
      entityName: EntityNames.EubopenCompound.singularEntityName,
      sections: [
        {
          id: 'Summary',
          title: 'Summary',
          component: Summary,
          index: 0,
        },
        {
          id: 'ProbeMechanism',
          title: 'Mechanism of Action',
          component: ProbeMechanism,
          index: 1,
        },
        {
          id: 'ProbeProfile',
          title: 'Activity Profile',
          component: ProbeProfile,
          index: 2,
        },
        {
          id: 'CalculatedProperties',
          title: 'Calculated Properties',
          component: CalculatedProperties,
          componentParams: {
            entityID: EntityNames.EubopenCompound.entityID,
          },

          index: 3,
        },
        {
          id: 'CrystalStructures',
          title: 'PBD Ligand Codes',
          component: CompoundCrystalStructures,
          index: 4,
        },
      ],
    }
  },
}

export default methods
